const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const DirectMessageSchema = new Schema({
  sender: {
    type: Schema.Types.ObjectId,
    ref: 'User',
    required: true
  },
  recipient: {
    type: Schema.Types.ObjectId,
    ref: 'User',
    required: true
  },
  content: {
    type: String,
    required: true
  },
  timestamp: {
    type: Date,
    default: Date.now
  },
}, { 
    timestamps: true
});

module.exports = mongoose.model('DirectMessage', DirectMessageSchema);
